require_relative 'treasure_trove'
require_relative 'playable'
module StudioGame
  class Player
    attr_accessor :health
    attr_accessor :name

    include Playable

  	def initialize(name, health=100)
  		@name = name.capitalize
      @health = health
      @found_treasure = Hash.new(0)
    end

    def to_s
      "I'm #{@name} with health = #{@health}, points = #{points}, and score = #{score}."
    end

    def score
      @health + points
    end 

    def <=>(other)
      other.score <=> score
    end

    def stats
      puts "#{@name} (#{health})"
    end

    def found_treasure(treasure)
      @found_treasure[treasure.name] += treasure.points
      puts "#{@name} found a #{treasure.name} worth #{treasure.points} points."
      puts "#{@name}'s treasures: #{@found_treasure}"
    end

    def points
      @found_treasure.values.reduce(0, :+)
    end

    def each_found_treasure    
      @found_treasure.each do |name, points|
        yield Treasure.new(name, points)
      end
    end

    def high_scores
      @name.ljust(20, '.') + score.to_s
    end

    def self.from_csv(line)
        name, health = line.split(',')
        Player.new(name, Integer(health))
    end
  end


  if __FILE__ == $0
    player = Player.new("moe")
    puts player.name
    puts player.health
    player.w00t
    puts player.health
    player.blam
    puts player.health
  end
end